export declare class Identity {
    id?: number;
    creationTime?: string;
    lastModificationTime?: string;
}
export declare class NamedIdentity {
    id?: number;
    name?: string;
}
export declare enum SortOrder {
    ById = 0,
    Alphabetical = 1,
}
export interface LookUpItemRaw extends NamedIdentity, Identity {
    parent_id?: number;
}
export interface LookUpItem extends NamedIdentity {
    parentId: number;
    children: LookUpItem[];
}
export interface SlideItem extends NamedIdentity {
    parentId: number;
    nextSlideIndex: number;
    selected?: boolean;
    slide: Slide;
    lookUpItem: LookUpItem;
}
export interface Slide {
    parentSlideItem: SlideItem;
    parentSlide: Slide;
    slideIndex: number;
    items: SlideItem[];
}
