import { Injectable } from '@angular/core';
// MODELS
import { SortOrder } from '../../models/models';
var MultiLevelSelectHelpers = (function () {
    function MultiLevelSelectHelpers() {
    }
    MultiLevelSelectHelpers.prototype.buildHierarchicalLookUp = function (lookups) {
        if (lookups && lookups.length > 0) {
            var _lookupsTree_1 = [];
            var addChildren_1 = function (parent) {
                lookups.forEach(function (value) {
                    if (value.parent_id === parent.id) {
                        var _child = { id: value.id, parentId: value.parent_id, name: value.name, children: [] };
                        parent.children.push(_child);
                        addChildren_1(_child);
                    }
                });
            };
            lookups.forEach(function (value) {
                if (value.parent_id == null) {
                    var _topParent = { id: value.id, parentId: null, name: value.name, children: [] };
                    _lookupsTree_1.push(_topParent);
                    addChildren_1(_topParent);
                }
            });
            return _lookupsTree_1;
        }
        else {
            return [];
        }
    };
    MultiLevelSelectHelpers.prototype.sortHierarchicalLookUpAsTreeInAscOrder = function (hierarchicalLookUpAsTree, sortBy) {
        var sortByPropertyName = null;
        var valueBeingSortedStrings = false;
        if (sortBy === SortOrder.ById) {
            // sort by id in asc order
            sortByPropertyName = 'id';
        }
        else if (sortBy === SortOrder.Alphabetical) {
            // sort by name in asc order
            sortByPropertyName = 'name';
            valueBeingSortedStrings = true;
        }
        else {
            throw new Error("Helpers provider: not supported sortBy param is provided. sortBy: " + JSON.stringify(sortBy));
        }
        var sortByFn = function (a, b) {
            var aValue = valueBeingSortedStrings ? a[sortByPropertyName].toLowerCase() : a[sortByPropertyName];
            var bValue = valueBeingSortedStrings ? b[sortByPropertyName].toLowerCase() : b[sortByPropertyName];
            // a is less than b by some ordering criterion
            if (aValue < bValue) {
                return -1;
            }
            // a is greater than b by the ordering criterion
            if (aValue > bValue) {
                return 1;
            }
            // a must be equal to b
            return 0;
        };
        var sortChildren = function (childrenToSort) {
            childrenToSort.sort(sortByFn);
            childrenToSort.forEach(function (value) {
                if (value.children && value.children.length > 0) {
                    sortChildren(value.children);
                }
            });
        };
        hierarchicalLookUpAsTree.sort(sortByFn);
        hierarchicalLookUpAsTree.forEach(function (value) {
            if (value.children && value.children.length > 0) {
                sortChildren(value.children);
            }
        });
    };
    MultiLevelSelectHelpers.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    MultiLevelSelectHelpers.ctorParameters = function () { return []; };
    return MultiLevelSelectHelpers;
}());
export { MultiLevelSelectHelpers };
//# sourceMappingURL=helpers.js.map